#include "OthelloApp.h"

#include <iostream>
#include <fstream>
#include <string>
#include "FKUT/Misc.h"


OthelloApp::OthelloApp(Fl_Window *argMainWin, fk_Window *argDrawWin)
	: fkut_AppBase(argMainWin, argDrawWin), tb(argDrawWin, &camera)
{
	// EBhEփV[o^
	drawWin->setScene(&scene);
}

OthelloApp::~OthelloApp(void)
{
	// EBhEV[̓o^
	drawWin->setScene(NULL);
}

void OthelloApp::init(void)
{
	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setDiffuse(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// zu4(ꎞIuWFNg)
	makeStone(fk_Vector( 5.0, 0.0,  5.0));
	makeStone(fk_Vector(-5.0, 0.0,  5.0));
	makeStone(fk_Vector(-5.0, 0.0, -5.0));
	makeStone(fk_Vector( 5.0, 0.0, -5.0));

	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.setBGColor(0.5, 0.5, 0.5);
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);
	// NX̂Ńo֐oRŃGg[
	board.entry(&scene);

	// eLXgEl\p
	textSpr.initFont("C:/Windows/Fonts/Meiryo.ttc");
	textSpr.drawText("\̈");
	textSpr.entryFirst(drawWin, &scene, &camera);
	textSpr.setPositionLT(-WINDOW_WIDTH*0.5, WINDOW_HEIGHT*0.5);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 100.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	return;
}

// NbNꏊ̍WlԂ(ՖʂɊւ鏈Board::checkCell())
fk_Vector OthelloApp::clickProc(void)
{
	fk_Plane	plane;
	fk_Vector	winPos, projPos;

	plane.setPosNormal(fk_Vector(0.0, 0.0, 0.0), fk_Vector(0.0, 1.0, 0.0));
	winPos = eveMan.getMousePosition();
	drawWin->getProjectPosition(winPos.x, winPos.y, &plane, &projPos);

	return projPos;
}

// ΂u
int OthelloApp::makeStone(const fk_Vector &argPos, StoneColor argColor)
{
	if(argColor == ST_DEFAULT) {
		// bIɁAԖڂ͍AԖڂ͔ɂ
		if(stoneArray.size() % 2 == 0) {
			stoneArray.push_back(new Stone(ST_BLACK));
		} else {
			stoneArray.push_back(new Stone(ST_WHITE));
		}
	} else {
		stoneArray.push_back(new Stone(argColor));
	}
	stoneArray.back()->setPosition(argPos);
	stoneArray.back()->entry(&scene);

	// Ֆʃf[^ɉԖڂ̐΂ûZbg
	board.setStoneID(argPos, stoneArray.size()-1);

	return (int)stoneArray.size();
}

void OthelloApp::clearStone(void)
{
	int num = stoneArray.size();
	for(int i = 0; i < num; ++i) {
		stoneArray[i]->remove(&scene);
		delete stoneArray[i];
	}
	stoneArray.clear();
	board.initBoard();

	return;
}


// t[̏
bool OthelloApp::update(void)
{
	// J̉]
	tb.update();
	// Cg̉]
	lightModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, 0.01);

	// }EXꂽ炻̏ꏊɐ΂u
	if(eveMan.getMouseStatus(FK_MOUSE1) == FKUT_SW_DOWN) {
		fk_Vector adjustPos;
		// Ԓl̒lɉď𕪊
		int result = board.checkCell(clickProc(), &adjustPos);
		switch(result) {
		case -1:
			makeStone(adjustPos);
			putMessage(fk_StrPrintf("(%d, %d)ɒu܂B",
				board.calcID(adjustPos.x), board.calcID(adjustPos.z)));
			break;
		case -2:
			putMessage("Ֆʂ̊Oɂ͒u܂B");
			break;
		default:
			stoneArray[result]->reverse();
			putMessage("ɒuĂ܂B");
			break;
		}
	}
	// t@C̏o(F2L[)Ɠ(F1L[)̃eXg
	if(eveMan.getSpecialKeyStatus(FK_F1) == FKUT_SW_DOWN) {
		if(loadState()) {
			putMessage("Load success.");
		} else {
			putMessage("Load failed.");
		}
	}
	if(eveMan.getSpecialKeyStatus(FK_F2) == FKUT_SW_DOWN) {
		if(saveState()) {
			putMessage("Save success.");
		} else {
			putMessage("Save failed.");
		}
	}

	// [6/5]]Aj[V̂߁ASĂ̐΂̏ԂXV
	int num = stoneArray.size();
	for(int i = 0; i < num; ++i) {
		stoneArray[i]->update();
	}

	return true;
}

// [6/5]u΂̃f[^eLXgt@Cɏo
bool OthelloApp::saveState(void)
{
	ofstream	out_file("fileIO.txt");

	if(!out_file.is_open()) return false;

	// ܂̓wb_sƁA΂̌o
	out_file << "[BOARD INFO]" << endl;
	int num = stoneArray.size();
	out_file << num << endl;
	// [v񂵂ĐF,x,y,z̏ɏo
	for(int i = 0; i < num; ++i) {
		fk_Vector tmpPos = stoneArray[i]->getPosition();
		out_file << stoneArray[i]->getColor() << "," << tmpPos.x << "," << tmpPos.y << "," << tmpPos.z << endl;
	}

	out_file.close();

	return true;
}

// [6/5]eLXgt@C͂Au΂̏Ԃ𕜌
bool OthelloApp::loadState(void)
{
	ifstream		in_file("fileIO.txt");
	string			str;
	vector<string>	strSplit;
	int				num = 0;

	if(!in_file.is_open()) return false;

	// ŏ̍s[BOARD INFO]ȂG[
	if(getline(in_file, str)) {
		if(str != "[BOARD INFO]") return false;
	} else {
		return false;
	}

	// ΂̌擾
	if(getline(in_file, str)) {
		num = atoi(str.c_str());
	} else {
		return false;
	}

	// ՖʂNA
	clearStone();

	// Ԃ񃋁[vAĔzuĂ
	for(int i = 0; i < num; ++i) {
		if(getline(in_file, str)) {
			// J}؂ŕ
			strSplit = fk_StrSplit(str, ",");
			// ڂ4ȏȂ珈AłȂ΃G[
			if(strSplit.size() >= 4) {
				// 3ZqŐF̒萔
				StoneColor	color = (atoi(strSplit[0].c_str()) == 0) ? ST_BLACK : ST_WHITE;
				// ʒuWfk_Vectorɕ
				fk_Vector	pos(atof(strSplit[1].c_str()), atof(strSplit[2].c_str()), atof(strSplit[3].c_str()));
				//fobO\
				//cout << pos.x << "," << pos.y << "," << pos.z << "," << color << endl;
				// ΂̔zu(Q[vCƓ֐g񂷂̂|Cg)
				makeStone(pos, color);
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	in_file.close();

	return true;
}

void OthelloApp::putMessage(string argText)
{
	textSpr.drawText(argText, true);
	textSpr.setPositionLT(-WINDOW_WIDTH*0.5, WINDOW_HEIGHT*0.5);

	return;
}
